<template>
  <PageWrapper>
    <a-card :bordered="false" class="pt-3 mb-3 proCard">
      <BasicForm @register="register" @submit="handleSubmit" @reset="handleReset">
        <template #statusSlot="{ model, field }">
          <a-input v-model="model[field]" />
        </template>
      </BasicForm>
    </a-card>
    <a-card :bordered="false" class="proCard">
      <BasicTable
        :columns="columns"
        :request="loadDataTable"
        :row-key="(row) => row.id"
        ref="tableRef"
        scroll-x="1200"
        :row-selection="{ onChange: onSelectionChange }"
        virtual-scroll
      >
        <template #tableTitle>
          <a-space>
            <a-button type="primary" @click="handleAdd" v-perm="['sys:article:add']">
              <template #icon>
                <PlusOutlined />
              </template>
              添加文章
            </a-button>

            <a-button
              type="danger"
              @click="handleDelete()"
              :disabled="!selectionData.length"
              v-perm="['sys:article:batchDelete']"
            >
              <template #icon>
                <DeleteOutlined />
              </template>
              删除
            </a-button>
          </a-space>
        </template>
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'action'">
            <a-space>
              <a-button
                type="primary"
                @click="handleEdit(record.id)"
                v-perm="['sys:article:update']"
              >
                <template #icon><EditOutlined /></template>
                编辑
              </a-button>
              <a-button
                type="primary"
                danger
                @click="handleDelete(record.id)"
                v-perm="['sys:article:delete']"
              >
                <template #icon><DeleteOutlined /></template>
                删除
              </a-button>
            </a-space>
          </template>
        </template>
      </BasicTable>
    </a-card>
    <editDialog
      v-if="editVisible"
      :articleId="articleId"
      v-model:visible="editVisible"
      @success="reloadTable('noRefresh')"
    />
  </PageWrapper>
</template>

<script lang="ts" setup>
  import { nextTick, reactive, ref, defineAsyncComponent } from 'vue';
  import { PlusOutlined, EditOutlined, DeleteOutlined } from '@ant-design/icons-vue';
  import { useForm } from '@/components/Form/index';
  import { getArticleList, articleDelete, articleBatchDelete } from '@/api/content/article';
  import { columns } from './columns';
  import { schemas } from './querySchemas';
  import { Modal, message } from 'ant-design-vue';

  /**
   * 定义参数变量
   */
  const articleId = ref(0);
  const tableRef = ref();
  const editVisible = ref(false);
  const selectionData = ref([]);

  /**
   * 导入组件
   */
  const editDialog = defineAsyncComponent(() => import('./edit.vue'));

  /**
   * 定义查询参数
   */
  const formParams = reactive({
    title: '',
    status: '',
  });

  /**
   * 加载数据列表
   * @param res 参数
   */
  const loadDataTable = async (res) => {
    const result = await getArticleList({ ...formParams, ...res });
    return result;
  };

  /**
   * 刷新数据列表
   * @param noRefresh 参数
   */
  function reloadTable(noRefresh = '') {
    tableRef.value.reload(noRefresh ? {} : { pageNo: 1 });
  }

  /**
   * 执行编辑
   * @param id 参数
   */
  async function handleEdit(id) {
    articleId.value = id;
    await nextTick();
    editVisible.value = true;
  }

  /**
   * 执行删除
   * @param id 参数
   */
  async function handleDelete(id) {
    Modal.confirm({
      title: '提示',
      content: '确定要删除？',
      onOk: async () => {
        id ? await articleDelete(id) : await articleBatchDelete(selectionData.value);
        message.success('删除成功');
        reloadTable();
      },
    });
  }

  /**
   * 执行提交表单
   * @param values 参数
   */
  function handleSubmit(values: Recordable) {
    for (const key in formParams) {
      formParams[key] = '';
    }
    for (const key in values) {
      formParams[key] = values[key];
    }
    reloadTable();
  }

  /**
   * 执行重置
   */
  function handleReset() {
    for (const key in formParams) {
      formParams[key] = '';
    }
    reloadTable();
  }

  /**
   * 选项发生变化
   * @param value 参数
   */
  function onSelectionChange(value) {
    selectionData.value = value;
  }

  /**
   * 注册
   */
  const [register, {}] = useForm({
    rowProps: { gutter: [16, 0] },
    colProps: {
      xs: 24,
      sm: 24,
      md: 12,
      lg: 8,
      xl: 6,
    },
    labelCol: { span: 6, offset: 0 },
    schemas,
  });

  /**
   * 执行添加
   */
  const handleAdd = async () => {
    articleId.value = 0;
    await nextTick();
    editVisible.value = true;
  };
</script>
